#include <libcrash-service.h>

#include <linux/limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void help(char *argv_0)
{
	printf("Usage: %s [-r dump_reason] pid\n", argv_0);
}

int main(int argc, char *argv[])
{
	int opt;
	const char *dump_reason = NULL;

	while ((opt = getopt(argc, argv, "r:")) != -1) {
		switch (opt) {
		case 'r':
			dump_reason = optarg;
			break;
		default:
			help(argv[0]);
			exit(EXIT_FAILURE);
		}
	}

	if (dump_reason == NULL)
		dump_reason = "no reason";

	if (optind >= argc) {
		help(argv[0]);
		exit(EXIT_FAILURE);
	}
	pid_t pid = strtol(argv[optind], NULL, 10);
	if (pid == 0) {
		printf("ERROR: pid must be a number\n");
		help(argv[0]);
		return EXIT_FAILURE;
	}

	char BUFF[PATH_MAX];
	bool res = livedump_pid(pid, dump_reason, BUFF, PATH_MAX);
	printf("res: %s\nreport_path: %s\n", res ? "true" : "false", BUFF);
	return res ? EXIT_SUCCESS : EXIT_FAILURE;
}
